! This file is part of HiggsBounds
!  -KW
!******************************************************************
module extra_bits_for_web
! This files deals with the webversion of HiggsBounds
!******************************************************************

#ifdef NAGf90Fortran
 use F90_UNIX_ENV, only : iargc,getarg
 use F90_UNIX_IO, only : flush
#endif

 implicit none

 contains
 !************************************************************	
 subroutine getlongcommandline2of2(Mh,Gammatot,gsq,BR_hjhihi,debugmode)
 !************************************************************	
 ! reads Mh,Gammatot,gsq,BR_hjhihi,debugmode from command line 
 ! note that debugmode for web version is different to other versions
 ! used for inputfile=F and whichinput='effC' only
 !************************************************************ 
  use usefulbits, only : nH,sqcouplratio  
  implicit none  
  !-------------------------------------output 
  double precision :: Mh(:),Gammatot(:)
  type(sqcouplratio) :: gsq
  double precision :: BR_hjhihi(:,:) 
  logical :: debugmode  
  !-----------------------------------internal 
#ifndef NAGf90Fortran
  integer :: iargc
#endif
  integer :: nargs,i,j,k,n_iargc
  character(LEN=100) :: temp
  !------------------------------------------- 
  nargs=  3  +  nH  +  nH  &
    &    + nH*6   &
    &    +((nH*(nH-1))/2+nH)  +  nH**2-nH   &
    &    + 1
   
  n_iargc=IARGC()

  if( n_iargc.ne. nargs  )then
   write(*,*)'IARGC()',n_iargc,'nargs',nargs
   if(n_iargc.eq.4)then
    write(*,*) "At the moment, inputmethod=website"
    write(*,*) "Did you want inputmethod=datfile instead?"
    write(*,*) "(i.e. the command line version of HiggsBounds)" 
    write(*,*) "If so, please send the authors an email saying that"
    write(*,*) "they have left the website settings in by accident. Thanks!"
    write(*,*) "In the meantime, you can change inputmethod to"
    write(*,*) "inputmethod=datfile in the file HiggsBounds.F90"
    call flush(6)
    stop "Incorrect number of parameters given (getlongcommandline2of2) A"
   else
    stop "Incorrect number of parameters given (getlongcommandline2of2) B"
   endif
  endif  
  
  ! Read arguments into text strings.
  k=4 !have already read whichexpt,whichinput and nH
  
  do i=1,nH
   call read_arg( Mh(i) ,k)   
  enddo   
  
  do i=1,nH
   call read_arg( Gammatot(i) ,k) 
  enddo  
    
  do i=1,nH
   call read_arg( gsq%hjbb(i) ,k) 
  enddo  
  
  do i=1,nH
   call read_arg( gsq%hjtautau(i) ,k) 
  enddo  
    
  do i=1,nH
   call read_arg( gsq%hjWW(i) ,k) 
  enddo  
  
  do i=1,nH
   call read_arg( gsq%hjZZ(i) ,k) 
  enddo  
  
  do i=1,nH
   call read_arg( gsq%hjgaga(i) ,k) 
  enddo  
  
  do i=1,nH
   call read_arg( gsq%hjgg(i) ,k) 
  enddo  
  
  do i=1,nH*(nH-1)/2+nH 
   call read_arg( gsq%hjhiZ_in(i) ,k)
  enddo
  
  BR_hjhihi=0.0D0
  do j=1,nH
   do i=1,nH		 
    if(i.ne.j) call read_arg( BR_hjhihi(j,i) ,k)	   	
   enddo
  enddo
  
  temp=""  
  call GETARG(k,temp)
  read(temp,*)debugmode   
  k=k+1
  
  if( (k-1) .ne. nargs  )then
   write(*,*)k-1,nargs
   call flush(6)
   stop "error in subroutine getlongercommandline2of2"
  endif
    
 end subroutine getlongcommandline2of2
 !************************************************************	
 subroutine getlongercommandline2of2(w_input,d,tR,debugmode)
 !************************************************************
 ! reads components of d and dT from command line 
 ! note that debugmode for web version is different to other versions
 ! used for inputfile=F and whichinput='part' or 'hadr' only
 !************************************************************
  use usefulbits, only : nH,dataset,tevextras
  implicit none
  !--------------------------------------input
  type(dataset) :: d
  type(tevextras) :: tR
  logical :: debugmode
  character(LEN=4) :: w_input
  !-----------------------------------internal
#ifndef NAGf90Fortran
  integer :: iargc
#endif
  integer :: nargs,i,j,k,n_iargc
  integer :: q
  character(LEN=100) :: temp
  !-------------------------------------------        	

  select case(w_input)
  case('part')
  ! number of acceptable arguments
  !    whichexpt,whichinput,nH,
  !    Mh, lepXS_hjZ_ratio,lepXS_hjhi_ratio,
  !    tevXS_vbf_ratio,
  !    tevR,
  !    BR_hjbb,BR_hjtautau,BR_hjWW,BR_hjgaga,BR_hjhihi,
  !    debugmode
   nargs=  1     +     1    + 1 &
    &   + nH+   nH          +(nH*(nH-1)/2)+nH &
    &   +   nH   +    nH    & 
    &   + tR%nq_hjWp*nH+tR%nq_hjWm*nH  +nH+nH  +tR%nq_hjZ*nH   &
    &   +   nH   +    nH+  nH   +     nH    + nH*(nH-1) &
    &   + 1   	 	 
  case('hadr')
  ! number of acceptable arguments
  !    whichexpt,whichinput,nH,
  !    Mh, lepXS_hjZ_ratio,lepXS_hjhi_ratio,
  !    XS_hj_ratio,XS_hjb_ratio,XS_hjW_ratio,XS_hjZ_ratio,XS_vbf_ratio
  !    BR_hjbb,BR_hjtautau,BR_hjWW,BR_hjgaga,BR_hjhihi,
  !    debugmode
   nargs=  1     +     1    + 1 &
    &   + nH+   nH          +(nH*(nH-1)/2)+nH &
    &   +   nH   +    nH  +   nH  +    nH  +    nH   &
    &   +   nH   +    nH+  nH   +     nH    + nH*(nH-1)&
    &   + 1  	 	 
  case default
   write(*,*)'w_input = ',w_input
   call flush(6)
   stop 'error in subroutine getlongercommandline2of2 (a)'
  end select
  
  n_iargc=IARGC()
  if( n_iargc.ne. nargs  )then
   write(*,*)'nargs',nargs
   write(*,*)'IARGC()',IARGC()
   call flush(6)

   if(n_iargc.eq.4)then
    write(*,*) "At the moment, inputmethod=website"
    write(*,*) "Did you want inputmethod=datfile instead?"
    write(*,*) "(i.e. the command line version of HiggsBounds)" 
    write(*,*) "If so, please send the authors an email saying that"
    write(*,*) "they have left the website settings in accidently. Thanks!"
    write(*,*) "In the meantime, you can change inputmethod to"
    write(*,*) "inputmethod=datfile in the file HiggsBounds.F90"
    call flush(6)
    stop "Incorrect number of parameters given (getlongercommandline2of2) A"
   else
    stop "Incorrect number of parameters given (getlongercommandline2of2) B"
   endif

  endif
  
  ! Read arguments into text strings.
  k=4 !have already read whichexpt,whichinput and nH
  
  do i=1,nH
   call read_arg( d%Mh(i) ,k) 
  enddo   	

  do i=1,nH
   call read_arg( d%lep%XS_hjZ_ratio(i) ,k) 
  enddo   
  		
  do j=1,nH
   do i=1,j		  
    call read_arg( d%lep%XS_hjhi_ratio(j,i) ,k)  	  
   enddo
  enddo	

  select case(w_input)
  case('part')    
   do i=1,nH
    call read_arg( d%tev%XS_vbf_ratio(i) ,k) 
   enddo    
   do i=1,nH
    call read_arg( tR%bg_hjb(i) ,k)  
   enddo    
   do q=1,tR%nq_hjWp   
    do i=1,nH
     call read_arg( tR%qq_hjWp(q,i) ,k) 
    enddo   
   enddo
   do q=1,tR%nq_hjWm  
    do i=1,nH
     call read_arg( tR%qq_hjWm(q,i) ,k)  
    enddo   
   enddo
   do i=1,nH
    call read_arg( tR%gg_hj(i) ,k) 
   enddo    
   do i=1,nH
    call read_arg( tR%qq_hj(5,i) ,k)   
   enddo     
   do q=1,tR%nq_hjZ  
    do i=1,nH
     call read_arg( tR%qq_hjZ(q,i) ,k)
    enddo 
   enddo 
  
  case('hadr')
   do i=1,nH
    call read_arg( d%tev%XS_hj_ratio(i) ,k)  
   enddo  
   do i=1,nH
    call read_arg( d%tev%XS_hjb_ratio(i) ,k)  
   enddo  
   do i=1,nH
    call read_arg( d%tev%XS_hjW_ratio(i) ,k)  
   enddo  
   do i=1,nH
    call read_arg( d%tev%XS_hjZ_ratio(i) ,k)  
   enddo    
   do i=1,nH
    call read_arg( d%tev%XS_vbf_ratio(i) ,k) 
   enddo  
  case default
   write(*,*)'w_input = ',w_input
   call flush(6)
   stop 'error in subroutine getlongercommandline2of2 (b)'
  end select  
	
  do i=1,nH		
   call read_arg( d%BR_hjbb(i) ,k) 
  enddo   

  do i=1,nH
   call read_arg( d%BR_hjtautau(i) ,k) 
  enddo   
     
  do i=1,nH
   call read_arg( d%BR_hjWW(i) ,k) 
  enddo   
    
  do i=1,nH
   call read_arg( d%BR_hjgaga(i) ,k) 
  enddo   
  
  d%BR_hjhihi=0.0D0
  do j=1,nH
   do i=1,nH		 
    if(i.ne.j) call read_arg( d%BR_hjhihi(j,i) ,k)	   	
   enddo
  enddo
  
  temp=""  
  call GETARG(k,temp)
  read(temp,*)debugmode   
  k=k+1   
       
  if( (k-1) .ne. nargs  )then
   write(*,*)'nargs=',nargs
   write(*,*)'k-1=',k-1
   call flush(6)
   stop "error in subroutine getlongercommandline2of2 (c)"
  endif    

 end subroutine getlongercommandline2of2
 !********************************************************
 subroutine read_arg(x,k)
 !********************************************************  
  implicit none
  double precision :: x
  integer :: k
  character(LEN=100) :: temp
  
  temp=""  
  call GETARG(k,temp)
  read(temp,*)x   
  k=k+1
  
  end subroutine read_arg
 !********************************************************	
 subroutine weboutput(r)
 !********************************************************
 ! writes results to screen in a form suitable for the webpage
 ! used for inputfile=F only 
 !********************************************************
  use usefulbits, only : results,pr,listprocesses
  use S95tables	
  implicit none
  !--------------------------------------input
  type(results) :: r
  !-----------------------------------internal  
  type(listprocesses) :: proc		
  integer :: ii
  character(LEN=150):: descrip 
  !-------------------------------------------	
		 
  write(*,*)'********************************************************'
  write(*,*)
  if(abs(r%allowed95(1))==1)then
   write(*,*)'parameter point is UNEXCLUDED at 95 per cent C.L.'	    	     
  else
   write(*,*)'parameter point is EXCLUDED at 95 per cent C.L.'	     	  
  endif	

  write(*,*)'using the process with highest statistical sensitivity:'	
  
  proc=pr(r%chan(1))
  call outputproc(proc,6,descrip) 
  write(6,*)trim(descrip)
	
  write(*,*)'which has a theoretical rate vs. limit of'
  write(*,*)r%obsratio(1)  
	
  if(size(r%chan).gt.1)then	
	
   write(*,*)	 
   write(*,*)'********************************************************'		  
   write(*,*)'**************   Additional Information   **************'
   write(*,*)	
  		
   do ii=2,size(r%chan)	 
    select case(ii)
    case(2)
     write(*,*)'process with second highest statistical sensitivity:'
    case(3) 
     write(*,*)'process with third highest statistical sensitivity:'
    case default
     write(*,*)'another process:'
    end select    

    ! recall that 6 is standard output	
    proc=pr(r%chan(ii))
    call outputproc(proc,6,descrip) 
    write(6,*)trim(descrip) 	 		  	
    
    if(r%chan(ii).gt.0)then	  	     
      if(abs(r%allowed95(ii))==1)then
       write(*,*)'On its own, this process would have not excluded this'    	    
       write(*,*)'parameter point at 95 per cent C.L.'
      else
       write(*,*)'On its own, this process would have excluded this' 
       write(*,*)'parameter point at 95 per cent C.L.'
      endif
    
      write(*,*)'since it has a theoretical rate vs. limit of'
      write(*,*)r%obsratio(ii)  		  			
      write(*,*)	
    endif     
   enddo
   
  endif		
  write(*,*)'********************************************************'
				
 end subroutine weboutput
 !************************************************************
 
end module
!******************************************************************
